<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>Composing A Pipeline</title><link rel="stylesheet" href="synopsis.css" type="text/css" /><meta name="generator" content="DocBook XSL Stylesheets V1.73.2" /><link rel="start" href="index.html" title="Synopsis Tutorial" /><link rel="up" href="scripting.html" title="Chapter 3. Scripting And Extending Synopsis" /><link rel="prev" href="processor.html" title="The Processor class" /><link rel="next" href="script.html" title="Writing your own synopsis script" /></head><body><div class="navheader"><table width="100%" summary="Navigation header"><tr><th colspan="3" align="center">Composing A Pipeline</th></tr><tr><td width="20%" align="left"><a accesskey="p" href="processor.html">Prev</a> </td><th width="60%" align="center">Chapter 3. Scripting And Extending Synopsis</th><td width="20%" align="right"> <a accesskey="n" href="script.html">Next</a></td></tr></table></div><div class="section" lang="en" xml:lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a id="pipeline"></a>Composing A Pipeline</h2></div></div></div><p>With such a design, processors can simply be chained together:</p><div class="mediaobject"><img src="images/pipeline.png" width="432" /></div><p>A parser creates an IR, which is passed to the linker (creating 
        a table of contents on the fly) which passes it further down to a
        formatter.</p><pre class="programlisting">parser = ...
linker = ...
formatter = ...
ir = IR()
ir = parser.process(ir, input=['source.hh'])
ir = linker.process(ir)
ir = formatter.process(ir, output='html')</pre><p>And, to be a little bit more scalable, and to allow the use of
      dependency tracking build tools such as make, the intermediate IRs can
      be persisted into files. Thus, the above pipeline is broken up into multiple
      pipelines, where the 'output' parameter of the parser is used to 
      point to IR stores, and the 'input' parameter of the linker/formatter 
      pipeline then contains a list of these IR store files.</p><div class="mediaobject"><img src="images/pipelines.png" width="432" /></div><p>Parse <code class="filename">source1.hh</code> and write the IR to <code class="filename">source1.syn</code>:</p><pre class="programlisting">parser.process(IR(), input = ['source1.hh'], output = 'source1.syn')</pre><p>Parse <code class="filename">source2.hh</code> and write the IR to <code class="filename">source2.syn</code>:</p><pre class="programlisting">parser.process(IR(), input = ['source2.hh'], output = 'source2.syn')</pre><p>Read in <code class="filename">source1.syn</code> and <code class="filename">source2.syn</code>, then link and format 
        into the <code class="filename">html</code> directory:</p><pre class="programlisting">formatter.process(linker.process(IR(), input = ['source1.syn', 'source2.syn']), output = 'html')</pre></div><div class="navfooter"><table width="100%" summary="Navigation footer"><tr><td width="40%" align="left"><a accesskey="p" href="processor.html">Prev</a> </td><td width="20%" align="center"><a accesskey="u" href="scripting.html">Up</a></td><td width="40%" align="right"> <a accesskey="n" href="script.html">Next</a></td></tr><tr><td width="40%" align="left" valign="top">The Processor class </td><td width="20%" align="center"><a accesskey="h" href="index.html">Home</a></td><td width="40%" align="right" valign="top"> Writing your own synopsis script</td></tr></table></div></body></html>
